datablock WheeledVehicleSpring(ModHatchSpring)
{
	length = 0.3;
	force = 5000;
	damping = 600;
	antiSwayForce = 3;
	
};

datablock WheeledVehicleTire(ModHatchTire)
{
	shapeFile = "./modernwheela.dts";

	mass = 10;
	radius = 1;
	staticFriction = 5;
	kineticFriction = 5;
	restitution = 0.5;	

	lateralForce = 18000;
	lateralDamping = 4000;
	lateralRelaxation = 0.01;

	longitudinalForce = 14000;
	longitudinalDamping = 2000;
	longitudinalRelaxation = 0.01;
};

datablock DebrisData(ModHatchTireDebris)
{
	emitters = "JeepTireDebrisTrailEmitter";

	shapeFile = "./modernwheela.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ExplosionData(ModHatchExplosion : vehicleExplosion)
{
	debris = ModHatchTireDebris;
	debrisNum = 4;
	debrisNumVariance = 0;
	debrisPhiMin = 0;
	debrisPhiMax = 360;
	debrisThetaMin = 40;
	debrisThetaMax = 85;
	debrisVelocity = 14;
	debrisVelocityVariance = 3;
};

datablock ProjectileData(ModHatchExplosionProjectile : vehicleExplosionProjectile)
{
	directDamage = 0;
	radiusDamage = 0;
	damageRadius = 0;
	explosion = ModHatchExplosion;

	directDamageType  = $DamageType::VehicleExplosion;
	radiusDamageType  = $DamageType::VehicleExplosion;

	explodeOnDeath = 1;

	armingDelay = 0;
	lifetime = 0;

	uiName = "";
};

datablock DebrisData(ModHatchDebris)
{
	emitters = "JeepDebrisTrailEmitter";

	shapeFile = "./modernhatchwreckage.dts";
	lifetime = 3.0;
	minSpinSpeed = -500.0;
	maxSpinSpeed = 500.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ExplosionData(ModHatchFinalExplosion : vehicleFinalExplosion)
{
	debris = ModHatchDebris;
	debrisNum = 1;
	debrisNumVariance = 0;
	debrisPhiMin = 0;
	debrisPhiMax = 360;
	debrisThetaMin = 0;
	debrisThetaMax = 20;
	debrisVelocity = 18;
	debrisVelocityVariance = 3;
};

datablock ProjectileData(ModHatchFinalExplosionProjectile : vehicleFinalExplosionProjectile)
{
   directDamage = 0;
   radiusDamage = 0;
   damageRadius = 0;
   explosion = ModHatchFinalExplosion;

   directDamageType = $DamageType::VehicleExplosion;
   radiusDamageType = $DamageType::VehicleExplosion;

   explodeOnDeath = 1;

   armingDelay = 0;
   lifetime = 0;

   uiName = "";
};

datablock WheeledVehicleData(ModHatchVehicle)
{
	category = "Vehicles";

	//- Render -
	shapeFile = "./modernhatch.dts";
	emap = true;

	//- Physics -
	mass = 300;
	drag = 1.6;
	density = 5.0;

	//- Damage/Energy -
	maxEnergy = 100;
	maxDamage = 200;
	destroyedLevel = 200;
	isInvincible = false;

	//- Camera -
	useEyePoint = false;

	//- Vehicle Data -
	jetForce = 3000.0;
	jetEnergyDrain = 2.0;
	minJetEnergy = 30.0;
	massCenter = "0.0 0.0 0.0";
	massBox = "0.0 0.0 0.0";
	bodyRestitution = 0.6;
	bodyFriction = 0.6;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	minImpactSpeed = 10.0;
	softImpactSpeed = 10.0;
	hardImpactSpeed = 15.0;
	maxSteeringAngle = 0.9785;
	integration = 4;
	collisionTol = 0.1;
	contactTol = 0.01;
	cameraRoll = false;
	cameraLag = 0.0;
	cameraDecay = 0.75;
	cameraOffset = 7.5;
	cameraMaxDist = 10.0;
	cameraTilt = 0.4;
	damageEmitter[0] = vehicleBurnEmitter;
	damageEmitter[1] = vehicleBurnEmitter;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;
	damageLevelTolerance[1] = 1.0;
	numDmgEmitterAreas = 1.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.6;
	exitSplashSoundVelocity = 5.0;
	softSplashSoundVelocity = 0.0;
	mediumSplashSoundVelocity = 10.0;
	hardSplashSoundVelocity = 20.0;
	uiName = "Hatchback";
	rideAble = true;
	
	//- Wheeled Vehicle -
	maxWheelSpeed = 38.0;
	engineTorque = 10000.0;
	engineBrake = 4000.0;
	brakeTorque = 20000.0;
	rollForce =	900.0;
	yawForce = 600.0;
	pitchForce = 3000.0;
	rotationalDrag = 0.2;
	stallSpeed = 0.0;
	steeringUseAutoReturn = true;
	steeringAutoReturnRate = 0.9;
	steeringAutoReturnMaxSpeed = 10;
	steeringUseStrafeSteering = true;
	steeringStrafeSteeringRate = 0.1;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	tireEmitter = vehicleTireEmitter;

	//- Mounting -
	minMountDist = 3;
	numMountPoints = 4;
	mountThread[0] = "sit";
	mountThread[1] = "sit";
	mountThread[2] = "sit";
	mountThread[3] = "sit";

	//- Vehicle Damage -
	speedDamageScale = 1.04;
	collDamageMultiplier = 0.02;
	collDamageThresholdVel = 20.0;

	//- Passenger Protection -
	protectPassengersBurn = false;
	protectPassengersRadius = true;
	protectPassengersDirect = false;

	//- RunOver -
	minRunOverSpeed = 4.0;
	runOverDamageScale = 8.0;
	runOverPushScale = 1.2;

	//- Misc -
	defaultTire	= ModHatchTire;
	defaultSpring = ModHatchSpring;
	numWheels = 4;
	paintable = true;
	initialExplosionProjectile = ModHatchExplosionProjectile;
	initialExplosionOffset = 0.0;
	finalExplosionProjectile = ModHatchFinalExplosionProjectile;
	finalExplosionOffset = 0.5;
	burnTime = 4000;
	lookUpLimit = 0.5;
	lookDownLimit = 0.5;
};

datablock WheeledVehicleData(ModHatchPoliceVehicle : ModHatchVehicle)
{
	//- Vehicle Data -
	uiName = "Hatchback - Police";
	maxWheelSpeed = 43.0;
};

datablock WheeledVehicleData(ModHatchTaxiVehicle : ModHatchVehicle)
{
	//- Vehicle Data -
	uiName = "Hatchback - Taxi";
};

function ModHatchPoliceSirenSO::addCar(%this,%obj)
{
	if(isObject(%obj))
		if(%obj.getDatablock() == ModHatchPoliceVehicle.getID())
			%this.car[%this.carCount++ - 1] = %obj;
	if(%this.carCount == 1)
		%this.loop();
}

function ModHatchPoliceSirenSO::removeCar(%this,%obj)
{
	for(%a = 0; %a < %this.carCount; %a++)
		if(%this.car[%a] == %obj)
			break;
	if(%a < %this.carCount)
		for(%b = %a; %b < %this.carCount; %b++)
			%this.car[%b] = %this.car[%b + 1];
}

function ModHatchPoliceSirenSO::loop(%this)
{
	cancel(%this.loop);
	
	if(%this.carCount > 0)
	{
		%this.state++;
		if(%this.state > 3)
			%this.state = 0;
		
		for(%a = 0; %a < %this.carCount; %a++)
		{
			if(!isObject(%this.car[%a]))
				%this.removeCar(%this.car[%a]);
			else
			{
				switch(%this.state)
				{
					case 0:
						%this.car[%a].unmountImage(1);
					case 1:
						if(%this.car[%a].useSiren)
							%this.car[%a].mountImage(BlockoSedanPoliceLightAImage,0);
					case 2:
						%this.car[%a].unmountImage(0);
					case 3:
						if(%this.car[%a].useSiren)
							%this.car[%a].mountImage(BlockoSedanPoliceLightBImage,0);
				}
			}
		}
		
		%this.loop = %this.schedule(250,loop);
	}
	else
		%this.schedule(0,delete);
}

function ModHatchVehicle::onAdd(%db,%this)
{
	%this.hideNode(taxi);
	%this.hideNode(police);
	
	parent::onAdd(%db,%this);
}

function ModHatchPoliceVehicle::onAdd(%db,%this)
{
	%this.hideNode(taxi);
	%this.unhideNode(police);
	
	if(!isObject(ModHatchPoliceSirenSO))
		new ScriptObject(ModHatchPoliceSirenSO);
	ModHatchPoliceSirenSO.addCar(%this);
	
	parent::onAdd(%db,%this);
}

function ModHatchTaxiVehicle::onAdd(%db,%this)
{
	%this.unhideNode(taxi);
	%this.hideNode(police);
	
	parent::onAdd(%db,%this);
}

package Vehicle_ModHatch
{
	function serverCmdLight(%client)
	{
		if(isObject(%client.player) && !isObject(%client.player.light))
		{
			%player = %client.player;
			%veh = %player.getControlObject();
			if(isObject(%veh))
				if(%veh.getDatablock() == ModHatchPoliceVehicle.getID())
				{
					%veh.useSiren = !%veh.useSiren;
					return "";
				}
		}
		parent::serverCmdLight(%client);
	}
	function Vehicle::setNodeColor(%this,%node,%color)
	{
		parent::setNodeColor(%this,%node,%color);
		if(%this.getDatablock() == ModHatchPoliceVehicle.getID() && %node $= "ALL")
		{
			%r = getWord(%color,0);
			%g = getWord(%color,1);
			%b = getWord(%color,2);
			%lowest = 1;
			for(%a = 0; %a < 3; %a++)
			{
				%val = getWord(%color,%a);
				if(%val > %highest)
					%highest = %val;
				if(%val < %lowest)
					%lowest = %val;
			}
			%average = atof(%r) + atof(%g) + atof(%b);
			%average /= 3;
			%sat = %highest - %lowest;
			if(%sat < 0.1 && %average > 0.25)
				%stripe = "0 0 0.5 1.0";
			else
				%stripe = "0.9 0.9 0.9 1.0";
			%this.setNodeColor("stripe",%stripe);
		}
	}
};
activatePackage(Vehicle_ModHatch);